<?php
/**
 * Smarty plugin
 * @package Smarty
 * @subpackage plugins
 */


/**
 * Smarty truncate modifier plugin
 *
 * Type:     modifier<br>
 * Name:     truncate<br>
 * Purpose:  Truncate a string to a certain length if necessary,
 *           optionally splitting in the middle of a word, and
 *           appending the $etc string or inserting $etc into the middle.
 * @link http://smarty.php.net/manual/en/language.modifier.truncate.php
 *          truncate (Smarty online manual)
 * @author   Monte Ohrt <monte at ohrt dot com>
 * @param string
 * @param integer
 * @param string
 * @param boolean
 * @param boolean
 * @return string
 */
if(!function_exists('truncate')){
	function truncate($needCutString='',$end_length = 20,$start=0,$endstring = '...'){
			/************************************************************************
			1) 由于一个汉字占2个字符，因此起始位置为n不等于由第n个字符开始，需要先找到起始位置的字符数。
			2) while循环结束，就可得到起始位置的字符数
			************************************************************************/
			$i = 0;
			$output = "";
			while($i < strlen($needCutString)) {
				// 循环执行的次数
				if($start-- == 0){break;}
				// 如果是汉字，字符数加2，否则字符数加1
				if(ord(substr($needCutString, $i, 1)) > 128){$i++;}
				$i++;
			}
			// 截取长度，起始位置则是while循环结束时变量i的值 
			for(; $i < strlen($needCutString); $i++){
				// 汉字，取2个字符
				if( ord(substr($needCutString, $i, 1)) > 128 ){
					$output .= substr($needCutString, $i, 2);
					$i++;
				}else{
					// 英文，取1个字符
					$output .= substr($needCutString, $i, 1);
				}
				// for循环结束标志，既可以是字符串尾部，也可以是截取长度。
				if(--$end_length == 0)break;
			}
			return $output.$endstring;
	}
}
//,$break_words = false, $middle = false
function smarty_modifier_truncate($string, $length = 20, $etc = '...')
{
    if ($length == 0)
        return '';
      	return truncate($string,$length,0,$etc);


   /* if (strlen($string) > $length) {
        $length -= min($length, strlen($etc));
        if (!$break_words && !$middle) {
            $string = preg_replace('/\s+?(\S+)?$/', '', substr($string, 0, $length+1));
        }
        if(!$middle) {
            return substr($string, 0, $length) . $etc;
        } else {
            return substr($string, 0, $length/2) . $etc . substr($string, -$length/2);
        }
    } else {
        return $string;
    }*/
}

/* vim: set expandtab: */

?>
